image: adoptopenjdk/openjdk11-openj9:alpine

stages:
  - build
  - test
  - image
  - deploy

variables:
  MAVEN_CLI_OPTS: -s .m2/settings.xml --batch-mode
  MAVEN_OPTS: -Dmaven.repo.local=.m2/repository
  JAVA_TOOL_OPTIONS: -Xmx300m
  IMAGE_TAG: $CI_REGISTRY_IMAGE:borda-empresa

cache:
  paths:
    - .m2/repository/
    - target/*.jar

build:
  stage: build
  script:
    - ./mvnw package -DskipTests
  only:
    - master

test:
  stage: test
  script:
    - ./mvnw test sonar:sonar -Dsonar.projectKey=${PROJETO} -Dsonar.organization=${ORGANIZACAO} -Dsonar.host.url=${SONAR_URL} -Dsonar.login=${SONAR_TOKEN}

build-image:
  image: docker:stable
  services:
    - docker:dind
  stage: image
  variables:
    DOCKER_HOST: tcp://docker:2375
    DOCKER_DRIVER: overlay2
  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
  script:
    - docker build -t $IMAGE_TAG .
    - docker push $IMAGE_TAG
  only:
    - master

deploy:
  image: lisboajeff/kubectl:latest
  stage: deploy
  environment:
    name: desenvolvimento
  before_script:
    - kubectl delete -f k8s/
    - sed -i "s/IfNotPresent/Always/" k8s/deployment.yaml
  script:
    - kubectl apply -f k8s/
  when: manual
  allow_failure: false
  only:
    - master

